
//@vs
//////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
#ifdef sd_PCT
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);
#endif

#ifdef sd_Color
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	//vs_out_1 = float4 (TUV0.xy, 0, 0);
#endif

#ifdef sd_Gray
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);
#endif

#ifdef sd_RGBAMask56
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);
	vs_out_2 = CLR1.xyzw;
#endif

#ifdef sd_RGBAMask22
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);
	vs_out_2 = CLR1.xyzw;
#endif

#ifdef sd_ShwRGB
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw;// * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);
#endif

#ifdef sd_Text
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);
	vs_out_2 = CLR1.xyzw;
#endif
#ifdef sd_Text1
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);
	vs_out_2 = CLR1.xyzw;
#endif
#ifdef sd_Text2
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);
	vs_out_2 = CLR1.xyzw;
#endif

#ifdef sd_MaskRGBxA
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw * UserColor.xyzw;
	vs_out_1 = float4 (TUV0.xy, TUV1.xy);
#endif

#ifdef sd_PCT_Fog
	float3 wP = (matW * POS0).xyz;					//world pos
	float dist = calc_distance (EyePos, wP);
	float fog = get_dis_alpha (dist, FogNear, FogFar);
	vs_out_p = matWVP * POS0;
	vs_out_0 = float4 (CLR0.xyz*5.0, CLR0.w*fog);
	vs_out_1 = float4 (TUV0.xy, 0, 0);
#endif

}

#endif


//@ps
//////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

#define DiffColor		ps_in_0.xyzw
#define TexUV				ps_in_1.xy
#define TexUV1			ps_in_1.zw
#define MaskColor		ps_in_2.xyzw

void main () 
{ 

#ifdef sd_PCT
	ps_out_c = texture2D (c_samp0, TexUV) * DiffColor;// * UserColor.xyzw;	
#endif

#ifdef sd_Color
	ps_out_c = DiffColor;// * UserColor.xyzw;	
#endif

#ifdef sd_Gray
	float4 texD = texture2D (c_samp0, TexUV);
	float sum = texD.x*0.3 + texD.y*0.4 + texD.z*0.3;
	ps_out_c = float4 (float3(sum,sum,sum)*DiffColor.xyz, texD.w*DiffColor.w);
#endif

#ifdef sd_RGBAMask56
	float4 texD = texture2D (c_samp0, TexUV) * MaskColor;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);
	ps_out_c = float4 (DiffColor.xyz, sum*DiffColor.w);
#endif
#ifdef sd_RGBAMask22
	float4 texD = texture2D (c_samp0, TexUV) * MaskColor;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);
	ps_out_c = float4 (sum*DiffColor.xyz, DiffColor.w);
#endif

#ifdef sd_ShwRGB
	float4 texD = texture2D (c_samp0, TexUV) * DiffColor.xyzw;
	float sum = 1.0 - saturate (texD.x + texD.y + texD.z);
	ps_out_c = float4 (0,0,0, sum*DiffColor.w);
#endif


#ifdef sd_Text
	float4 texD = texture2D (c_samp0, TexUV) * MaskColor;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);
	float F = saturate (0.0 + (sum - 0.1) * 1.3);
	//sum = saturate (sum * 3.0);
	sum = sum * sum;
	ps_out_c = float4 (DiffColor.xyz*F, sum*DiffColor.w);
#endif
#ifdef sd_Text1
	float4 texD = texture2D (c_samp0, TexUV) * MaskColor;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);
	sum = saturate (sum * 1.0);
	ps_out_c = float4 (DiffColor.xyz, sum*DiffColor.w);
#endif
#ifdef sd_Text2
	float4 texD = texture2D (c_samp0, TexUV) * MaskColor;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);
	sum = saturate (sum * 1.0);
	ps_out_c = float4 (sum*DiffColor.xyz, sum*DiffColor.w);
#endif

#ifdef sd_MaskRGBxA
	float4 texD = texture2D (c_samp0, TexUV)  * DiffColor.xyzw;
	float mask = texture2D (c_samp0, TexUV1).w;
	ps_out_c = float4 (texD.x, texD.y, texD.z, mask * DiffColor.w);
#endif

#ifdef sd_PCT_Fog
	ps_out_c = texture2D (c_samp0, TexUV) * DiffColor;
#endif


}

#endif










