
//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

	#define s_FogNear					c_parm11.x					
	#define s_FogFar					c_parm11.y

void main () 
{	
	float3 wP = (matW * POS0).xyz;
	float dist = calc_distance (EyePos, wP.xyz);
	float alpha = get_dis_alpha (dist, s_FogNear, s_FogFar);

	vs_out_p = matVP * float4 (wP.xyz, 1.0);
	vs_out_1 = float4 (TUV0.xy, wP.z, 0);

#ifdef sd_General
	float3 diff = float3(Ambient, Ambient, Ambient) + (SunColor * CLR0.w) + (ShwColor.xyz * ShwColor.w * pow((1.0 - CLR0.w), 1.0));
	diff += (CLR0.xyz * 5.0 * LitIntensity);
	vs_out_0 = float4 (diff.xyz*UserColor.xyz, (saturate(alpha)*UserColor.w));
#endif

}

#endif



//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

	#define DiffColor		ps_in_0.xyzw
	#define TexUV				ps_in_1.xy
	#define WPosZ				ps_in_1.z

void main () 
{ 
#ifdef sd_General
	ps_out_c = texture2D (c_samp0, TexUV ) * DiffColor;
	//ps_out_c = DiffColor;
#endif

}

#endif







