//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
	float3 wP = (matW * POS0).xyz;					//world pos
	float dist = calc_distance (EyePos, wP);
	float fog = get_dis_alpha (dist, FogNear, FogFar);

	//float uv0inc = CTIME_MS * UV0Speed;
	//float uv1inc = CTIME_MS * UV1Speed;

	wP.x += wP.z * 0.1 * sin (wP.x + CTIME_MS*2.0);
	wP.y += wP.z * 0.1 * cos (wP.y + CTIME_MS*2.0);

	vs_out_p = (matVP * float4(wP, 1.0));	//screen pos
	vs_out_0 = float4 (CLR0.xyz, CLR0.w*fog);
	vs_out_1 = float4 (TUV0.xy, 0, 0);
}

#endif


//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

#define DiffColor		ps_in_0.xyzw
#define TexUV				ps_in_1.xy

void main () 
{ 
	ps_out_c = texture2D (c_samp0, TexUV) * DiffColor;

	//float4 rclr = texture2D (c_samp0, TexUV) * DiffColor;
	//if (rclr.w < 0.01) discard;
	//ps_out_c = rclr;
}


#endif






